package org.kxml.opt;

import java.util.*;
import java.io.*;
import org.kxml.parser.*;


public class BufferedXmlParser extends AbstractXmlParser {

    int bufPos;
    Vector buffer = new Vector ();
    AbstractXmlParser parser;

    public BufferedXmlParser (AbstractXmlParser parser) {

	this.parser = parser;
    }


    public ParseEvent read () throws IOException {
	if (bufPos < buffer.size ()) 
	    return (ParseEvent) buffer.elementAt (bufPos++);
	
	ParseEvent result = parser.read ();
	buffer.addElement (result);
	bufPos++;
	return result;
    }


    public ParseEvent peek () throws IOException{
	if (bufPos < buffer.size ()) 
	    return (ParseEvent) buffer.elementAt (bufPos);

	return parser.peek ();
    }


    public void reset () {
	bufPos = 0;
    }
}
